package dev.shadowsoffire.apotheosis.village.compat;

import net.minecraft.world.item.crafting.Ingredient;
import java.util.List;
import mezz.jei.api.recipe.RecipeIngredientRole;
import java.util.Arrays;
import mezz.jei.api.recipe.IFocusGroup;
import mezz.jei.api.gui.builder.IRecipeLayoutBuilder;
import mezz.jei.api.ingredients.IIngredientType;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.block.Blocks;
import mezz.jei.api.constants.VanillaTypes;
import dev.shadowsoffire.apotheosis.village.fletching.FletchingScreen;
import mezz.jei.api.helpers.IGuiHelper;
import net.minecraft.network.chat.Component;
import mezz.jei.api.gui.drawable.IDrawable;
import mezz.jei.api.recipe.RecipeType;
import net.minecraft.resources.ResourceLocation;
import dev.shadowsoffire.apotheosis.village.fletching.FletchingRecipe;
import mezz.jei.api.recipe.category.IRecipeCategory;

public class FletchingCategory implements IRecipeCategory<FletchingRecipe>
{
    public static final ResourceLocation UID;
    public static final RecipeType<FletchingRecipe> TYPE;
    private final IDrawable background;
    private final IDrawable icon;
    private final Component localizedName;
    
    public FletchingCategory(final IGuiHelper guiHelper) {
        final ResourceLocation location = FletchingScreen.TEXTURES;
        this.background = (IDrawable)guiHelper.createDrawable(location, 6, 16, 139, 54);
        this.icon = guiHelper.createDrawableIngredient((IIngredientType)VanillaTypes.ITEM_STACK, (Object)new ItemStack((ItemLike)Blocks.f_50622_));
        this.localizedName = (Component)Component.m_237115_("apotheosis.recipes.fletching");
    }
    
    public IDrawable getBackground() {
        return this.background;
    }
    
    public IDrawable getIcon() {
        return this.icon;
    }
    
    public Component getTitle() {
        return this.localizedName;
    }
    
    public RecipeType<FletchingRecipe> getRecipeType() {
        return FletchingCategory.TYPE;
    }
    
    public void setRecipe(final IRecipeLayoutBuilder builder, final FletchingRecipe recipe, final IFocusGroup focuses) {
        int i = 0;
        final List<List<ItemStack>> inputs = recipe.m_7527_().stream().map(i -> Arrays.asList(i.m_43908_())).toList();
        for (i = 0; i < 3; ++i) {
            builder.addSlot(RecipeIngredientRole.INPUT, 42, 1 + i * 18).addIngredients((IIngredientType)VanillaTypes.ITEM_STACK, (List)inputs.get(i));
        }
        builder.addSlot(RecipeIngredientRole.OUTPUT, 117, 19).addIngredient((IIngredientType)VanillaTypes.ITEM_STACK, (Object)recipe.getOutput());
    }
    
    static {
        UID = new ResourceLocation("apotheosis", "fletching");
        TYPE = RecipeType.create("apotheosis", "fletching", (Class)FletchingRecipe.class);
    }
}
